import java.math.* ;
import java.util.* ;
/*
  QS

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2005 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/

class Collector {
  private boolean over ;
  private int remains ;
  private int maxPrime ;
  private int collected ;
  private int width, height ;
  private BitSet seen = new BitSet () ;
  private int delta ;
  private int [] base ;

  int seePrime(int j) {
    if (!seen.get(j)) {
      seen.set(j) ;
      width++ ;
    }
    return base[j] ;
  }

  boolean isOver() { return over ; }

  private Hashtable t ;

  Collector (int delta, int [] base) {
    remains = delta + base.length ;
    this.delta = delta ;
    this.maxPrime = base[base.length-1] ;
    this.base = base ;
    t = new Hashtable(101) ;
  }

  boolean store(BigInteger x, int [] ps) {
    int len = ps.length ;
    int lastPrime = ps[len-1] ;
    if (lastPrime <= maxPrime) {
      System.out.print(x + ":") ;
      for (int i = 0 ; i < len ; i++) {
        System.out.print((char)' ') ;
        System.out.print(seePrime(ps[i])) ;
      }
      System.out.println() ;
      height++ ;
    } else {
      Integer key = new Integer(lastPrime) ;
      LargePrime v = (LargePrime)t.get(key) ;
      if (v == null) {
        collected++ ;
        t.put(key, new LargePrime(x, ps)) ;
        return over ;
      } else {
        v.combine(this, x, ps) ;
        height++ ;
      }
    }
    remains-- ;
    return over = (remains <= 0) || (height - width >= delta) ;
  }

  void efficiency() {
    System.err.println("Collected: " + collected +
                       ", Remains: " + remains +
                       ", height: " + height +
                       ", width: "  + width) ;
    
  }
}
