import java.math.* ;
/*
  QS

 Luc Maranget, projet Moscova, Inria Rocquencourt
 
 Copyright 2005 Institut National de Recherche en Informatique et    
 en Automatique.  All rights reserved.  This file is distributed     
 under the terms of the Q Public License version 1.0.          
*/

class Root {
  private int [] p ;
  private int [] r ;
  BigInteger n ;

  private Root(int [] p, BigInteger n) {
    this.p = p ;
    this.n = n ;
    r = new int [p.length] ;
  }


  private int [] roots() {
    r[0] = 0 ;
    r[1] = 1 ;
    for (int i = 2 ; i < p.length ; i++) {
      r[i] = Arith.sqrtMod(n, p[i]) ;
    }
    return r ;
  }

  static int [] compute(int [] p, BigInteger n) {
    return new Root(p, n).roots() ;
  }
}
